<?php

namespace Pinpoint\FeaturesManager\Controller\Adminhtml\Index;

use Magento\Backend\App\Action;

/**
 * Class Create
 * @package Pinpoint\FeaturesManager\Controller\Adminhtml\Index
 */
class Create extends Action
{
    /**
     * @var \Magento\Backend\Model\View\Result\Forward
     */
    protected $_resultForwardFactory;

    /**
     * @param \Magento\Backend\App\Action\Context $context
     * @param \Magento\Backend\Model\View\Result\ForwardFactory $resultForwardFactory
     */
    public function __construct(
       \Magento\Backend\App\Action\Context $context,
       \Magento\Backend\Model\View\Result\ForwardFactory $resultForwardFactory
   ) {
        $this->_resultForwardFactory = $resultForwardFactory;
        parent::__construct($context);
    }

    /**
     * {@inheritdoc}
     */
    protected function _isAllowed()
    {
        return $this->_authorization->isAllowed('Magento_Catalog::catalog');
    }

    /**
     * Forward to edit
     *
     * @return \Magento\Backend\Model\View\Result\Forward
     */
    public function execute()
    {
        /** @var \Magento\Backend\Model\View\Result\Forward $resultForward */
        $resultForward = $this->_resultForwardFactory->create();
        return $resultForward->forward('edit');
    }
}
