<?php

namespace Pinpoint\FeaturesManager\Model;

use Magento\Framework\Model\AbstractModel;
use Pinpoint\FeaturesManager\Api\Data\ProductFeaturesInterface;

/**
 * @method \Pinpoint\FeaturesManager\Model\ResourceModel\ProductFeatures getResource()
 * @method \Pinpoint\FeaturesManager\Model\ResourceModel\ProductFeatures\Collection getCollection()
 */
class ProductFeatures extends AbstractModel implements
    ProductFeaturesInterface,
    \Magento\Framework\DataObject\IdentityInterface
{
    /**
     * @var string
     */
    const CACHE_TAG = 'pinpoint_featuresmanager_productfeatures';

    /**
     * @var string
     */
    protected $_cacheTag = 'pinpoint_featuresmanager_productfeatures';

    /**
     * @var string
     */
    protected $_eventPrefix = 'pinpoint_featuresmanager_productfeatures';

    /**
     * {@inheritDoc}
     */
    protected function _construct()
    {
        $this->_init('Pinpoint\FeaturesManager\Model\ResourceModel\ProductFeatures');
    }

    /**
     * @return array|string[]
     */
    public function getIdentities()
    {
        return [self::CACHE_TAG . '_' . $this->getId()];
    }
}
